// JavaScript Document
<!--
/*

showPages v1.1
=================================

Infomation
----------------------
Author : Lapuasi
E-Mail : lapuasi@gmail.com
Web : http://www.lapuasi.com
Date : 2005-11-17


Example
----------------------
var pg = new showPages('pg');
pg.pageCount = 20; //ҳ(Ҫ)
pg.argName = 'p';    //(ѡ,ȱʡΪpage)
pg.printHtml();        //ʾҳ


Supported in Internet Explorer, Mozilla Firefox
*/

function showPages(name) { //ʼ
	this.name = name;      //
	this.page = 1; 			//ǰҳ
	this.pageCount=1	
	this.argName = 'page'; //
	this.showTimes = 1;    //ӡ
}

showPages.prototype.getPage = function(){ //urlõǰҳ,ظֻȡһ
	var args = location.search;
	var reg = new RegExp('[\?&]?' + this.argName + '=([^&]*)[&$]?','gi');
	var chk = args.match(reg);
	if (chk != null){
	this.page = RegExp.$1;}

}
showPages.prototype.checkPages = function(){ //еǰҳҳ֤
	if (isNaN(parseInt(this.page))) this.page = 1;
	if (isNaN(parseInt(this.pageCount))) this.pageCount = 1;
	if (this.page < 1) this.page = 1;
	if (this.pageCount < 1) this.pageCount = 1;
	if (this.page > this.pageCount) this.page = this.pageCount;
	this.page = parseInt(this.page);
	this.pageCount = parseInt(this.pageCount);
}
showPages.prototype.createHtml = function(mode){ //html
	var strHtml = '', prevPage = this.page - 1, nextPage = this.page + 1;
	if (mode == '' || typeof(mode) == 'undefined') mode = 1;
	switch (mode) {
		case 1 : //ģʽ1 (10ҳ,ҳ,ǰҳ,ҳ,βҳ)
			strHtml += '<span class="count">ҳ: ' + this.page + ' / ' + this.pageCount + '</span>';
			strHtml += '<span class="number">';
			if (prevPage < 1) {
				strHtml += '<span title="ҳ">ҳ</span>';
				strHtml += '<span title="һҳ">һҳ</span>';
			} else {
				strHtml += '<span title="ҳ"><a href="javascript:' + this.name + '.toPage(1);">ҳ</a></span>';
				strHtml += '<span title="һҳ"><a href="javascript:' + this.name + '.toPage(' + prevPage + ');">һҳ</a></span>';
			}
			if (this.page % 10 ==0) {
				var startPage = this.page - 9;
			} else {
				var startPage = this.page - this.page % 10 + 1;
			}
			if (startPage > 10) strHtml += '<span title="ǰ10ҳ"><a href="javascript:' + this.name + '.toPage(' + (startPage - 1) + ');">...</a></span>';
			for (var i = startPage; i < startPage + 10; i++) {
				if (i > this.pageCount) break;
				if (i == this.page) {
					strHtml += '<span title="Page ' + i + '">' + i + '</span>';
				} else {
					strHtml += '<span title="Page ' + i + '"><a href="javascript:' + this.name + '.toPage(' + i + ');">' + i + '</a></span>';
				}
			}
			if (this.pageCount >= startPage + 10) strHtml += '<span title="10ҳ"><a href="javascript:' + this.name + '.toPage(' + (startPage + 10) + ');">...</a></span>';
			if (nextPage > this.pageCount) {
				strHtml += '<span title="һҳ">һҳ</span>';
				strHtml += '<span title="βҳ">βҳ</span>';
			} else {
				strHtml += '<span title="һҳ"><a href="javascript:' + this.name + '.toPage(' + nextPage + ');">һҳ</a></span>';
				strHtml += '<span title="βҳ"><a href="javascript:' + this.name + '.toPage(' + this.pageCount + ');">βҳ</a></span>';
			}
			strHtml += '</span><br />';
			break;
		case 4 : //ģʽ4 ()
			if (this.pageCount < 1) {
				strHtml += '<select name="toPage" disabled>';
				strHtml += '<option value="0">No Pages</option>';
			} else {
				var chkSelect;
				strHtml += '<select name="toPage" onchange="' + this.name + '.toPage(this);">';
				for (var i = 1; i <= this.pageCount; i++) {
					if (this.page == i) chkSelect=' selected="selected"';
					else chkSelect='';
					strHtml += '<option value="' + i + '"' + chkSelect + '>Pages: ' + i + ' / ' + this.pageCount + '</option>';
				}
			}
			strHtml += '</select>';
			break;
		default :
			strHtml = 'Javascript showPage Error: not find mode ' + mode;
			break;
	}
	return strHtml;
}
showPages.prototype.createUrl = function (page) { //ҳתurl
	if (isNaN(parseInt(page))) page = 1;
	if (page < 1) page = 1;
	if (page > this.pageCount) page = this.pageCount;
	var url = location.protocol + '//' + location.host + location.pathname;
	var args = location.search;
	var reg = new RegExp('([\?&]?)' + this.argName + '=[^&]*[&$]?', 'gi');
	args = args.replace(reg,'$1');
	if (args == '' || args == null) {
		args += '?' + this.argName + '=' + page;
	} else if (args.substr(args.length - 1,1) == '?' || args.substr(args.length - 1,1) == '&') {
			args += this.argName + '=' + page;
	} else {
			args += '&' + this.argName + '=' + page;
	}
	return url + args;
}
showPages.prototype.toPage = function(page){ //ҳת
	var turnTo = 1;
	if (typeof(page) == 'object') {
		turnTo = page.options[page.selectedIndex].value;
	} else {
		turnTo = page;
	}
	self.location.href = this.createUrl(turnTo);
}
showPages.prototype.printHtml = function(mode){ //ʾhtml
	this.getPage();
	this.checkPages();
	this.showTimes += 1;
	document.write('<div id="pages_' + this.name + '_' + this.showTimes + '" class="pages"></div>');
	document.getElementById('pages_' + this.name + '_' + this.showTimes).innerHTML = this.createHtml(mode);
	
}
showPages.prototype.formatInputPage = function(e){ //޶ҳʽ
	var ie = navigator.appName=="Microsoft Internet Explorer"?true:false;
	if(!ie) var key = e.which;
	else var key = event.keyCode;
	if (key == 8 || key == 46 || (key >= 48 && key <= 57)) return true;
	return false;
}
//-->